=== debian/changelog ===
docker.io (17.03.2-0ubuntu1~17.10.1) artful; urgency=medium

  * Backport to Artful (LP: #1732368)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 17 Nov 2017 13:38:42 +1300

docker.io (17.03.2-0ubuntu1) bionic; urgency=medium

  * Update to 17.03.2 upstream release

 -- Tianon Gravi <tianon@debian.org>  Wed, 01 Nov 2017 12:30:17 -0700

docker.io (1.13.1-0ubuntu6) artful; urgency=medium

  * Add missing "runc" patches for LXD-enablement

 -- Tianon Gravi <tianon@debian.org>  Wed, 11 Oct 2017 19:38:03 -0700

docker.io (1.13.1-0ubuntu5) artful; urgency=medium

  * Replace "runc" dependency with a multiorig copy of Docker's exact supported
    commit contents (installed as "/usr/bin/docker-runc" mirroring upstream's
    package)
  * Replace "containerd" in the same way (with the exact upstream-supported
    commit, binaries installed as "/usr/bin/docker-containerd*")

 -- Tianon Gravi <tianon@debian.org>  Fri, 29 Sep 2017 13:22:39 -0700

docker.io (1.13.1-0ubuntu4) artful; urgency=medium

  * d/tests/docker-in-lxd: Better handle DNS with systemd-resolved.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 21 Sep 2017 01:12:33 -0400

docker.io (1.13.1-0ubuntu3) artful; urgency=medium

  * d/tests/docker-in-lxd: check for network-up has a race condition when
    systemd-resolved is used.  Add an additional check for a real DNS server
    in systemd-resolve --status.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Sep 2017 23:32:16 -0700

docker.io (1.13.1-0ubuntu2) artful; urgency=medium

  * d/tests/docker-in-lxd: copy more apt config into container
  * d/golang-github-docker-docker-dev.install: install missing packages.
    (LP: #1714564)
  * d/control: Add Build-Depend on tzdata.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 04 Sep 2017 13:31:34 +1200
